local L = LibStub("AceLocale-3.0"):GetLocale("AVRE", false)
local AVRE = AVRE
local mod = AVRE:NewModule("Options", "AceConsole-3.0")
local zones = LibStub("AceLocale-3.0"):GetLocale("AVRE Zones")



local newOrder
do
	local current = 0
	function newOrder()
		current = current + 1
		return current
	end
end



--[[
      OPTIONS ------------------------------------------------------------------------------------------------------------------
  ]]

AVRE.options = {
	name = "AVR Encounters         r|cff20ff20"..AVRE.MINOR_VERSION.."|r",
	handler = VampArrow,
	type = "group",
	args = {		

		enabled = {
			type = "toggle",
			name = L["Enable AVR Encounters"],
			get = function() return AVRE.db.profile.enabled end,
			set = function(self, val)
				AVRE.db.profile.enabled = val
				if val then AVRE:Enable() else AVRE:Disable() end
			end,
			order = newOrder(),
		}, -- enabled
		
		wotlk = {
			name = L["Wrath of the Lich King"],
			type = "group",
			order = newOrder(),
			args = {
			
				enabled = {
					type = "toggle",
					name = L["Enable Expansion"],
					get = function() return AVRE.db.profile.enc.wotlk.enabled end,
					set = function(self, val) AVRE.db.profile.enc.wotlk.enabled = val end,
					order = newOrder(),
				}, -- enabled

				icecrown = {
					name = zones["Icecrown Citadel"],
					type = "group",
					order = newOrder(),
					args = {
						
						enabled = {
							type = "toggle",
							name = L["Enable Raid Instance"],
							get = function() return AVRE.db.profile.enc.wotlk.icecrown.enabled end,
							set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.enabled = val end,
							order = newOrder(),
						}, -- enabled
						
						
-- FESTERGUT -------------------------------------------------------------------------------------------------------

						festergut = {
							name = L["Festergut"],
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.festergut.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.festergut.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								gasSpore = {
									type = "toggle",
									name = GetSpellInfo(69279),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(69279)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.festergut.gasSpore end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.festergut.gasSpore = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- ROTFACE ---------------------------------------------------------------------------------------------------------

						rotface = {
							name = L["Rotface"],
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.rotface.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.rotface.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								explosion = {
									type = "toggle",
									name = GetSpellInfo(69839),
									desc = format(L["Places a circle under all players during %s."], GetSpellInfo(69839)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.rotface.explosion end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.rotface.explosion = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- PUTRICIDE -------------------------------------------------------------------------------------------------------

						putricide = {
							name = L["Professor Putricide"],
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.putricide.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.putricide.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								malleable = {
									type = "toggle",
									name = GetSpellInfo(72615),
									desc = format(L["Places a circle under players with %s."].." "..L["Only works for one of the players."], GetSpellInfo(72615)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.putricide.malleable end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.putricide.malleable = val end,
									order = newOrder(),
								},
								
								plague = {
									type = "toggle",
									name = GetSpellInfo(72855),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(72855)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.putricide.plague end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.putricide.plague = val end,
									order = newOrder(),
								},
								
								sick = {
									type = "toggle",
									name = GetSpellInfo(70953),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(70953)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.putricide.sick end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.putricide.sick = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- SINDRAGOSA ------------------------------------------------------------------------------------------------------

						sindragosa = {
							name = L["Sindragosa"],
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.sindragosa.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.sindragosa.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								beacon = {
									type = "toggle",
									name = GetSpellInfo(70126),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(70126)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.sindragosa.beacon end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.sindragosa.beacon = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- LICH KING -------------------------------------------------------------------------------------------------------

						lichking = {
							name = L["The Lich King"],
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								defile = {
									type = "toggle",
									name = GetSpellInfo(72762),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(72762)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.defile end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.defile = val end,
									order = newOrder(),
								},
								
								shadowtrap = {
									type = "toggle",
									name = GetSpellInfo(73539),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(73539)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.shadowtrap end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.shadowtrap = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
					},
				},
				
			},
		},

	}
}



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function mod:OnInitialize()
	-- Register options
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AVRE", AVRE.options)
	AVRE.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AVRE", "AVR Encounters")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AVRE-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(AVRE.db))
	AVRE.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AVRE-Profiles", "Profiles", "AVR Encounters")
	AVRE.modules.options.loaded = true
end


function mod:OnEnable()
--[===[@debug@
	self:Print(L["Loaded"])
--@end-debug@]===]
end
